<template>
    <div class="main">
		<v-snackbar v-model="snack" top color="success">Contraseña actualizada</v-snackbar>
		<h1 class="white--text" v-if="expired">Petición expirada</h1>
		<v-card elevation="20" color="grey lighten-3">
			<v-card-text>
				<v-row>
					<v-col>
						<img :src="require('../../assets/cozcytLogo.png')" />
					</v-col>
				</v-row>
				<v-row>
					<v-col>
						<v-form>
							<v-card outlined>
								<v-card-title class="textCenter mb-2">Escribe tu nueva contraseña</v-card-title>
								<v-card-text>
								        <v-text-field
								        	prepend-icon="fas fa-key"
								        	label="Contraseña"
								        	:rules="rulesPass"
								        	outlined
											:disabled="expired"
								        	:append-icon="showPass ? 'fa-eye-slash' : 'fa-eye'"
								        	:type="showPass ? 'text' : 'password'"
								        	@click:append="showPass = !showPass"
								        	v-model="user.pass"
								        	required
								        />
								        <v-text-field
									        prepend-icon="fas fa-key"
									        label="Confirmar contraseña"
									        :rules="confirmPass"
									        outlined
											:disabled="expired"
									        :append-icon="showComparePass ? 'fa-eye-slash' : 'fa-eye'"
									        :type="showComparePass ? 'text' : 'password'"
									        @click:append="showComparePass = !showComparePass"
									        v-model="comparePass"
											@keydown.enter="newPassword(user)"
									        required
								        />
										<v-btn block color="warning" :to="{ name: 'Login' }" v-if="expired">Ir a inicio</v-btn>
                                        <v-btn :disabled="snack" block color="success" @click="newPassword(user)" v-else>Confirmar</v-btn>
								</v-card-text>
							</v-card>
						</v-form>
					</v-col>
				</v-row>
			</v-card-text>
		</v-card>
		<Footer />
	</div>
</template>

<script>
import crypto from "crypto-js";
import Footer from '@/components/Footer.vue';
import { mapActions } from "vuex";
import EventBus from "../../bus";
import router from "../../router";

export default {
	name:"UpdatePassword",
	components: { Footer },
    data:() => ({
		snack:false,
		showPass: false,
        showComparePass: false,
		comparePass: "",
		key:"",
		expired: null,
        user:{
            curp:"",
            pass:""
        },
        rulesPass: [
			value => !!value || "Campo requerido",
			value => (value || "").length >= 8 || "Mínimo 8 carácteres"
		],
    }),
    computed:{
        // Verifica ambas contraseñas sean correctas
		confirmPass() {
			return [
				this.user.pass === this.comparePass ||
					"Las contraseñas no coinciden"
			];
		}
	},
	methods:{
		...mapActions(["newPassword"])
	},
	created(){
		this.user.curp = this.$route.params.key;
		this.key = this.$route.params.key.replace(/_/g,"/");
		const bytes = crypto.AES.decrypt(this.key, "d6F3Efeq");
		const data = JSON.parse(bytes.toString(crypto.enc.Utf8));
		const now = new Date();
		const exp = new Date(data.exp);
		this.expired = (now.getTime() >= exp.getTime());

	},
	mounted(){
		EventBus.$on("succNewPassword",() => {
			this.snack = true;
			setTimeout(() => {
				this.snack = false;
				router.push({ name: "Login" });
			}, 2000);
		});
	}
}
</script>

<style scoped>
.main {
	background-color: #558b2f;
	height: 100%;
	display: flex;
	flex-direction: column;
	align-items: center;
	justify-content: center;
}
.textCenter {
	display: flex;
	justify-content: center;
}
</style>